﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Swap1337Admin
{
    class Program
    {
        static void Main(string[] args)
        {
            int a = 5;
            int b = 3;

            Console.WriteLine(string.Format("Before swap\na= {0}, \tb= {1}", a, b));

            Swap_with_third_variable(ref a, ref b);

            Console.WriteLine(string.Format("\nAfter swap with third variable\na= {0}, \tb= {1}", a, b));

            Swap_with_no_third_variable(ref a, ref b);

            Console.WriteLine(string.Format("\nAfter swap with NO third variable\na= {0}, \tb= {1}", a, b));

            Swap_bitwise(ref a, ref b);

            Console.WriteLine(string.Format("\nAfter swap bitwise\na= {0}, \tb= {1}", a, b));

            Console.ReadLine();
        }

        public static void Swap_with_third_variable(ref int a, ref int b)
        {
            // for example we will consider that a=5, and b=3
            int temp = a; // we create temporary variable in memory for keeping the value of a
            a = b; // here a becomes 3
            b = temp; // b gets the value of temp and now b=5
            // at the end we have a=3, b=5
        }

        public static void Swap_with_no_third_variable(ref int a, ref int b)
        {            
            // for example we will consider that a=3, and b=5
            a = a + b; // the value of a here will become 3+5 = 8
            b = a - b; // the value of b will be 8-5=3;
            a = a - b; // the value of a will be 8-3(note how new value of b is 3 already from the previous step)=5
            // at the and we have a=5, b=3
        }

        public static void Swap_bitwise(ref int a, ref int b)
        {
            a ^= b;
            b ^= a;
            a ^= b;
        }
    }
}
